﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.ServiceModel.Security;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Syncfusion.UI.Xaml.Diagram;
using System.Collections.ObjectModel;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace NestedObjects_115429
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            (Diagram.SelectedItems as SelectorViewModel).QuickCommands = Visibility.Collapsed;
            ObservableCollection<CustomNode> nodes = new ObservableCollection<CustomNode>();
            ObservableCollection<GroupViewModel> groups = new ObservableCollection<GroupViewModel>();
            CustomNode n1 = CreateNodes(100, 100);
            CustomNode n2 = CreateNodes(300, 300);
            CustomNode n3 = CreateNodes(400, 400);
            CustomNode n4 = CreateNodes(500, 500);
            GroupViewModel g = new GroupViewModel()
            {
                Nodes = new ObservableCollection<object>()
                {
                    n1,n2
                }
            };
            groups.Add(g);
            nodes.Add(n1);
            nodes.Add(n2);

            nodes.Add(n3);
            nodes.Add(n4);
          
            Diagram.Nodes = nodes;
            Diagram.Groups = groups;
        }

        private CustomNode CreateNodes(double x, double y)
        {
            return new CustomNode()
            {
                UnitWidth = 100,
                UnitHeight = 100,
                OffsetX = x,
                OffsetY = y,
                //Unique Guid for NodeViewModel
                ID = Guid.NewGuid(),

                //Shape for NodeViewModel
                Shape = new RectangleGeometry() { Rect = new Rect(0, 0, 10, 10) },

                //ShapeStyle
                ShapeStyle = this.Resources["shapestyle"] as Style,
            }; 
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void ButtonBase_OnClick(object sender, RoutedEventArgs e)
        {
            (Diagram.Groups.First() as GroupViewModel).Constraints |= NodeConstraints.Selectable;
            foreach (var item in (Diagram.Groups.First() as GroupViewModel).Nodes)
            {
                (item as CustomNode).Visibility = Visibility.Visible;
                (item as CustomNode).Constraints = (item as CustomNode).Constraints | NodeConstraints.Selectable;
            }
        }

        private void ButtonBase_OnClick1(object sender, RoutedEventArgs e)
        {
            (Diagram.Groups.First() as GroupViewModel).Constraints ^= NodeConstraints.Selectable;
            foreach (var item in (Diagram.Groups.First() as GroupViewModel).Nodes)
            {
                (item as CustomNode).Visibility = Visibility.Collapsed;
                (item as CustomNode).Constraints = (item as CustomNode).Constraints ^ NodeConstraints.Selectable;
            }
        }
    }

    public class CustomNode : NodeViewModel
    {
        private Visibility _mVisibility;

        public Visibility Visibility
        {
            get { return _mVisibility; }
            set
            {
                _mVisibility = value;
                OnPropertyChanged("Visibility");
            }
        }
        
    }

    public class CustomDiagram : SfDiagram
    {
        protected override Node GetNodeForItemOverride(object item)
        {
            Node g = new Node();
            Binding visi = new Binding();
            visi.Source = (item as CustomNode);
            visi.Path = new PropertyPath("Visibility");
            g.SetBinding(VisibilityProperty, visi);
            return g;
        }
    }

}
